#include "DAQDataFormats/RawRunTail.h"

#ifndef RAWBUFF32
// Define a macros to make accessing the raw buffer easier
#define RAWBUFF32 ((uint32_t*)this->_Buffer)
#define RAWBUFF16 ((uint16_t*)this->_Buffer)
#endif

using namespace daqdataformats;



//------------------------Constructors------------------------------------------
RawRunTail::RawRunTail(){

    // Set pointers to point to the internal buffer
    this->resetBufferSource();

    // Initialize it
    this->init();
}

//------------------------------------------------------------------------------
RawRunTail::RawRunTail(const RawRunTail& copy_in){

    this->copy(copy_in);
}

//------------------------------------------------------------------------------
RawRunTail::RawRunTail(void* nanosliceheader_buffer){

    // First, initialize the Internal Buffer
            // Set pointers to point to the internal buffer
            this->resetBufferSource();

            // Initialize it
            this->init();

    // Now set the pointer to the external buffer
    this->setBufferSource(nanosliceheader_buffer);
}

//------------------------Destructor--------------------------------------------
RawRunTail::~RawRunTail() { }


//------------------------------------------------------------------------------
// Deep Copy Method
void RawRunTail::copy(const RawRunTail& copy_in){
    // Copy the data from one buffer to the other
    for(uint32_t i = 0; i < this->sizeofdata(); ++i)
        _InternalBuffer[i] = copy_in._InternalBuffer[i];

    // Setup the main buffer pointer
    // If the copy_in's buffer is external, point to that external memory
    if(copy_in.isInternalBuffer()) this->resetBufferSource();
    else                           this->setBufferSource(copy_in._Buffer);


}

//------------------------------------------------------------------------------
// Default initialization at wherever the pointer points
void RawRunTail::init(){

    for(uint32_t i = 0; i < this->sizeofdata(); ++i)
        RAWBUFF32[i] = 0;

    this->setRunSize(RUNHEADER_SIZE);

    this->setTail();
}
