#include <vector>
#include <stdio.h>
#include <stdlib.h>

#include "DAQDataFormats/RawMicroSlice.h"        // Front Endboard Simulator

using namespace daqdataformats;

//! A short program to test RawMicroSlice
int main(){
  
std::cout<<"RawMicroSlice Test"<<std::endl;

std::cout<<"Empty rawmicroslice1"<<std::endl;
RawMicroSlice *microslice1 = new RawMicroSlice();
microslice1->getTimingMarker()->generate();
microslice1->print();


NanoSlice params;
        params.Header.LinkStatus          = true;
        params.Header.DataPresent         = true;
        params.Header.DebugMode           = false;
        params.Header.FEBLinkID           = 2;
        params.Header.FEBStatus           = 0x40;
        params.Header.PixelAddress        = 22;
        params.Header.FrameSequenceNumber = 5;
        params.TimeStamp                  = 1001;
        params.PulseHeight                = 89;





std::cout<<"Non empty nanoslice"<<std::endl;
RawNanoSlice *nanoslice_nonempty = new RawNanoSlice(params);
nanoslice_nonempty->print();



unsigned int buffer[200];
void* pbuffer = (void*) buffer; //pointer to the buffer
std::cout<<"Writing nanoslicenanoslice_nonempty to a buffer... ";
nanoslice_nonempty->writeData(pbuffer);

std::cout<<"Adding the nanoslice to the microslice. And add generator"<<std::endl;
microslice1->addNanoSlice(pbuffer);
microslice1->setHitProbability(.0001);
//microslice1->generate();
microslice1->print();




std::cout<<"Empty rawmicroslice2"<<std::endl;
RawMicroSlice microslice2;

microslice1->writeData(pbuffer);
microslice2.readData(pbuffer);

std::cout<<"rawmicroslice2 now:"<<std::endl;
microslice2.print();


//std::cout<<"rawmicroslice3:"<<std::endl;
//RawMicroSlice microslice3(microslice2);
//microslice3.print();

std::cout<<"rawmicroslice3 now:"<<std::endl;
RawMicroSlice microslice4(microslice2);
microslice4.print();
RawMicroSlice microslice5;
unsigned int* pointer = (unsigned int*)microslice4.getBuffer();
microslice5.setBufferSource(pointer);
microslice5.print();

microslice5.setFloatingNanoSlice(0);

microslice5.getFloatingNanoSlice()->print();

//RawMicroSlice micr_small(2);


/*RawMicroSlice micr_small(10);

micr_small.addNanoSlice(nanoslice_nonempty->getBuffer());
micr_small.addNanoSlice(nanoslice_nonempty->getBuffer());
micr_small.addNanoSlice(nanoslice_nonempty->getBuffer());
micr_small.print();
*/


return 0;
} // END MAIN
