#include <vector>
#include <stdio.h>
#include <stdlib.h>
#include "DAQDataFormats/RawNanoSliceHeader.h"        // Front Endboard Simulator

using namespace daqdataformats;

//! A short program to test RawNanoSliceHeader
int main(){
  
std::cout<<"RawNanoSliceHeader Test"<<std::endl;

std::cout<<"Empty nanosliceheader1:"<<std::endl;
RawNanoSliceHeader *header1 = new RawNanoSliceHeader();
header1->print();


std::cout<<"\nNon empty nanosliceheader2:"<<std::endl;

NanoSliceHeader params;
        params.LinkStatus          = true;
        params.DataPresent         = true;
        params.DebugMode           = false;
        params.FEBLinkID           = 53;
        params.FEBStatus           = 170;
        params.PixelAddress        = 22;
        params.FrameSequenceNumber = 5;

RawNanoSliceHeader *header2 = new RawNanoSliceHeader(params);

header2->print();std::cout<<"\n";

unsigned int buffer[1];
unsigned int* pbuffer = (unsigned int*)buffer;
std::cout<<"\n\nWriting nanosliceheader2 to a buffer... ";
header2->writeData(pbuffer);
printf("Buffer = 0x%08x\n", buffer[0]);

std::cout<<"\nReading the buffer to nanosliceheader1";
header1->readData(buffer);

std::cout<<"nanosliceheader1 now:"<<std::endl;
header1->print();std::cout<<"\n";

RawNanoSliceHeader header3(*header1);
header3.print();

RawNanoSliceHeader header4;
unsigned int* pointer = (unsigned int*)header3.getBuffer();
header4.setBufferSource(pointer);
header4.print();
std::cout<<"\n";

return 0;

} // END MAIN
