#include <vector>
#include <stdio.h>
#include <stdlib.h>

#include "DAQDataFormats/RawNanoSlice.h"        // Front Endboard Simulator

using namespace daqdataformats;

//! A short program to test RawNanoSlice
int main(){
  
std::cout<<"RawNanoSlice Test"<<std::endl;

std::cout<<"Empty nanosliceheader1"<<std::endl;
RawNanoSlice header1;
header1.print();

 NanoSlice params;
        params.Header.LinkStatus          = true;
        params.Header.DataPresent         = true;
        params.Header.DebugMode           = false;
        params.Header.FEBLinkID           = 2;
        params.Header.FEBStatus           = 6;
        params.Header.PixelAddress        = 22;
        params.Header.FrameSequenceNumber = 5;
        params.TimeStamp                  = 1001;
        params.PulseHeight                = 89;
        params.Reserved                   = rawnano::cafe_word;
        //params.Reserved                   = 0;


std::cout<<"Non empty nanosliceheader2"<<std::endl;
RawNanoSlice header2(params);

header2.print();


unsigned int buffer[3];
unsigned int* pbuffer = (unsigned int*) buffer;
std::cout<<"Writing nanosliceheader2 to a buffer... ";
header2.writeData(pbuffer);

std::cout<<"Reading the buffer to nanosliceheader1";
header1.readData(pbuffer);

std::cout<<"nanosliceheader1 now"<<std::endl;
header1.print();

RawNanoSlice nanoslice3(header1);
nanoslice3.print();

RawNanoSlice nanoslice4;
unsigned int* pointer = (unsigned int*)nanoslice3.getBuffer();
nanoslice4.setBufferSource(pointer);
nanoslice4.print();


std::cout<<"Checking for cafe..."<<nanoslice4.checkReservedForCafe()<<"\n";

return 0;
} // END MAIN
